SystemOrganization addCategory: #'TP2-TADP'!
SystemOrganization addCategory: #'TP2-TADP-Tests'!

Object subclass: #ComposicionATrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'!

!ComposicionATrait methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/1/2013 18:06'!
agregarMetodosDeLaClaseConJerarquia: unaClaseConJerarquia AlTraitConNombre:unNombreDeTrait

	| implementacionDeMetodos |
	
	implementacionDeMetodos := Set new.
	unaClaseConJerarquia methodDictionary do:[:unMetodo| implementacionDeMetodos add: unMetodo getSource].
	! !

!ComposicionATrait methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/1/2013 18:18'!
asignarUsoDelTraitConNombre: unNombreDeTrait aLaClase: unaClase

	unaClase uses: unNombreDeTrait.! !

!ComposicionATrait methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/1/2013 01:51'!
componerEnTraitsLaClase:unaClase conNombreDeAtributoComposicion:unNombreDeAtributo conClaseConJerarquia:unaClaseConJerarquia
		
		self crearTraitsDeClaseConJearquia:unaClaseConJerarquia.	
		self asignarUsoDeTraitConNombre: unNombreDeAtributo class aLaClase: unaClase.
		self eliminarAtributoConNombre: unNombreDeAtributo DeLaClase:unaClase.! !

!ComposicionATrait methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 4/30/2013 03:05'!
crearTraitConNombre:unNombreDeTrait
 
		Trait named: #unNombreDeTrait
       			uses: {}
       			category: 'TP2-TADP'! !

!ComposicionATrait methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 5/1/2013 18:16'!
crearTraitsDeClaseConJearquia:unaClaseConJerarquia
	|traitsACrear|
		
		traitsACrear:=Set new.
		traitsACrear add: unaClaseConJerarquia; add: unaClaseConJerarquia allSubclasses.
		traitsACrear do:[ :unaClaseQueVaASerUnTrait | self crearTraitConNombre: unaClaseQueVaASerUnTrait name;agregarMetodosDeLaClaseConJerarquia: unaClaseQueVaASerUnTrait AlTraitConNombre:unaClaseQueVaASerUnTrait name].
		
		
! !

!ComposicionATrait methodsFor: 'as yet unclassified' stamp: 'IvanOliveri 4/30/2013 03:14'!
eliminarAtributoConNombre: unNombreDeAtributo DeLaClase:unaClase

		unaClase removeInstVarNamed:unNombreDeAtributo.! !

Object subclass: #MetaUtil
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-Tests'!

!MetaUtil class methodsFor: 'as yet unclassified' stamp: 'Demian 9/8/2012 00:29'!
recreateCategory: categoryName
	(SystemOrganization listAtCategoryNamed: categoryName) do: [ :typeName | Smalltalk removeClassNamed: typeName ].
	SystemOrganization removeCategory: categoryName.
	FileStream fileIn: categoryName , '.st'.
	SystemOrganization sortCategories! !

Object subclass: #TheBlob
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'!

Object subclass: #TheInterceptor
	instanceVariableNames: 'afterCode beforeCode theClasses theMethods'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP'!

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 19:18'!
addACategory: unaCategoriaString
	theClasses addAll: (Object subclasses select: [ :aClass | aClass category == (unaCategoriaString asSymbol)]).

! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 18:28'!
addClasses: anString
	| classesNames |
	classesNames := anString subStrings: ' '.
	theClasses addAll: (classesNames collect: [ :name | Compiler evaluate: name]).! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:38'!
agregarCodigo
	| codes |
	codes := self getTheMethods collect: [ :method | self getBeforeCode , method sourceCode, self getAfterCode ].
	^codes! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:45'!
getAfterCode
	
	^ afterCode! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:47'!
getBeforeCode
	
	^ beforeCode! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 18:24'!
getTheClasses
	
	^ theClasses! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:38'!
getTheMethods
	
	^ theMethods! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 19:27'!
initialize 
	theClasses := Bag new.
	theMethods := Bag new.! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:35'!
methodsBeginWith: anString
	| allMethods |
	allMethods := (theClasses collect: [ :aClass | aClass methods]).
	^ allMethods gather: [ :arrayMethods | arrayMethods select:  [:aMethod | (aMethod selector beginsWith: anString asSymbol)]].! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:37'!
selectAccessors
	theMethods addAll: (self methodsBeginWith: 'set').
	theMethods addAll: (self methodsBeginWith: 'get').! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:36'!
selectMethodsBeginWith: anString
	theMethods addAll: (self methodsBeginWith: anString)! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:46'!
setAfterCode: anObject
	
	afterCode := anObject! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 17:47'!
setBeforeCode: anObject
	
	beforeCode := anObject! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 18:23'!
setTheClasses: anObject
	
	theClasses := anObject! !

!TheInterceptor methodsFor: 'accessing' stamp: 'GonzaloGobeaAlcoba 4/25/2013 20:38'!
setTheMethods: anObject
	
	theMethods := anObject! !

TestCase subclass: #RefactorsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-Tests'!

!RefactorsTest methodsFor: 'as yet unclassified' stamp: 'FedericoAloi 4/30/2013 01:17'!
setUp
	MetaUtil recreateCategory: 'TP2-TADP'! !

RefactorsTest subclass: #TheBlobTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TP2-TADP-Tests'!

!TheBlobTest commentStamp: '<historical>' prior: 0!
A TheBlobTest is a test class for testing the behavior of TheBlob!
